# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments to toni@links2linux.de

# norootforbuild

Name:			stk
Version:		4.4.1
Release:		1.pm.1.3
Summary:		Synthesis ToolKit in C++
Group:			System/Libraries
License:		MIT
URL:			http://ccrma.stanford.edu/software/stk/
Source0:		http://ccrma.stanford.edu/software/stk/release/stk-4.4.1.tar.gz
Source90:		%{name}-rpmlintrc
Patch0:			%{name}-gcc44.patch
Patch1:			%{name}-sharedlib.patch
Patch2:			%{name}-missing-shebang.patch
BuildRoot:		%{_tmppath}/%{name}-%{version}-%{release}-root-
BuildRequires:	alsa-devel
BuildRequires:	fdupes
BuildRequires:	gcc-c++
BuildRequires:	libjack-devel

%description
The Synthesis ToolKit in C++ (STK) is a set of open source audio
signal processing and algorithmic synthesis classes written in the C++
programming language. STK was designed to facilitate rapid development
of music synthesis and audio processing software, with an emphasis on
cross-platform functionality, realtime control, ease of use, and
educational example code. The Synthesis ToolKit is extremely portable
(it's mostly platform-independent C and C++ code), and it's completely
user-extensible (all source included, no unusual libraries, and no
hidden drivers). We like to think that this increases the chances that
our programs will still work in another 5-10 years. In fact, the
ToolKit has been working continuously for about 10 years now. STK
currently runs with realtime support (audio and MIDI) on Linux,
Macintosh OS X, and Windows computer platforms. Generic, non-realtime
support has been tested under NeXTStep, Sun, and other platforms and
should work with any standard C++ compiler.

%package devel
Summary:	Development files for stk
Group:		Development/Languages/C and C++
Requires:	libstk4 = %{version}
Requires:	alsa-devel
Requires:	libjack-devel

%description devel
The package contains libraries and header files for
developing applications that use stk.

%package -n libstk4
Summary:	Shared libraries for stk
Group:		System/Libraries

%description -n libstk4
Shared libraries for package stk.

%package demo
Summary:	Demo applications for stk
Group:		System/Libraries
Requires:	tk
Requires:	%{name} = %{version}

%description demo
The demo package contains the demo applications for the
C++ Sound Synthesis ToolKit.



%prep
%setup0 -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

%__rm projects/demo/tcl/Drums.tcl~

%build
export SUSE_ASNEEDED=0
export CPPFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
export CXXFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
%configure \
	--with-jack \
	--with-alsa \
	RAWWAVE_PATH=%{_datadir}/stk/rawwaves

%__make %{?jobs:-j%{jobs}} -C src
%__make %{?jobs:-j%{jobs}} -C projects/demo libdemo libMd2Skini
%__make %{?jobs:-j%{jobs}} -C projects/examples -f libMakefile
%__make %{?jobs:-j%{jobs}} -C projects/effects libeffects
%__make %{?jobs:-j%{jobs}} -C projects/ragamatic libragamat

%install
%__install -dm 755 %{buildroot}%{_bindir}
%__cp -p projects/demo/Md2Skini \
	%{buildroot}%{_bindir}/Md2Skini

%__install -dm 755 %{buildroot}%{_libdir}
%__cp -pd src/libstk.* \
	%{buildroot}%{_libdir}

%__install -dm 755 %{buildroot}%{_includedir}/%{name}
%__cp -p include/* \
	%{buildroot}%{_includedir}/%{name}

%__install -dm 755 %{buildroot}%{_datadir}/%{name}/rawwaves
%__cp -p rawwaves/*.raw \
	%{buildroot}%{_datadir}/%{name}/rawwaves

%__install -dm 755 %{buildroot}%{_datadir}/%{name}/demo
%__cp -p projects/demo/demo \
	%{buildroot}%{_bindir}/%{name}-demo
%__cp -pr projects/demo/tcl \
	%{buildroot}%{_datadir}/%{name}/demo
%__cp -pr projects/demo/scores \
	%{buildroot}%{_datadir}/%{name}/demo

for f in Banded Drums Modal Physical Shakers StkDemo Voice; do
	%__chmod 755 projects/demo/$f
	%__sed -e 's|./demo|%{_bindir}/stk-demo|g' -e '1i#! /bin/sh' \
		-i projects/demo/$f
	%__cp -p projects/demo/$f \
		%{buildroot}%{_datadir}/%{name}/demo
done

%__install -dm 755 %{buildroot}%{_datadir}/%{name}/examples
%__cp -pr projects/examples/midifiles \
	%{buildroot}%{_datadir}/%{name}/examples
%__cp -pr projects/examples/rawwaves \
	%{buildroot}%{_datadir}/%{name}/examples
%__cp -pr projects/examples/scores \
	%{buildroot}%{_datadir}/%{name}/examples
for f in audioprobe bethree controlbee crtsine \
	duplex foursine grains inetIn inetOut midiprobe \
	play playsmf record rtsine sine sineosc threebees; do
	%__cp -p projects/examples/$f \
		%{buildroot}%{_bindir}/%{name}-$f
	pushd %{buildroot}%{_datadir}/%{name}/examples
		ln -s %{_bindir}/%{name}-$f $f
	popd
done

%__install -dm 755 %{buildroot}%{_datadir}/%{name}/effects
%__cp -pr projects/effects/tcl \
	%{buildroot}%{_datadir}/%{name}/effects
%__cp -p projects/effects/effects \
	%{buildroot}%{_bindir}/%{name}-effects
%__sed -i -e 's|./effects|%{_bindir}/%{name}-effects|g' -e '1i#! /bin/sh' \
	projects/effects/StkEffects
%__cp -p projects/effects/StkEffects \
	%{buildroot}%{_datadir}/%{name}/effects

%__install -dm 755 %{buildroot}%{_datadir}/%{name}/ragamatic
%__cp -pr projects/ragamatic/tcl \
	%{buildroot}%{_datadir}/%{name}/ragamatic
%__cp -pr projects/ragamatic/rawwaves \
	%{buildroot}%{_datadir}/%{name}/ragamatic
%__cp -p projects/ragamatic/ragamat \
	%{buildroot}%{_bindir}/%{name}-ragamat
%__sed -i -e 's|./ragamat|%{_bindir}/stk-ragamat|g' -e '1i#! /bin/sh' \
	projects/ragamatic/Raga
%__cp -p projects/ragamatic/Raga \
	%{buildroot}%{_datadir}/%{name}/ragamatic

# fix encoding
iconv -f iso-8859-1 -t utf-8 \
	doc/doxygen/index.txt \
	-o doc/doxygen/index.txt.tmp
%__mv doc/doxygen/index.txt.tmp \
	doc/doxygen/index.txt
%fdupes -s doc

%clean
[ -d "%{buildroot}" -a "%{buildroot}" != "" ] && %__rm -rf "%{buildroot}"

%post -n libstk4 -p /sbin/ldconfig

%postun -n libstk4 -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc README
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/rawwaves
%{_datadir}/%{name}/rawwaves/*

%files -n libstk4
%defattr(-,root,root)
%{_libdir}/libstk.so.*

%files devel
%defattr(-,root,root)
%doc README doc/*
%{_libdir}/libstk.a
%{_libdir}/libstk.so
%{_includedir}/*

%files demo
%defattr(-,root,root)
%doc README
%{_bindir}/%{name}-*
%{_bindir}/Md2Skini
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/demo
%{_datadir}/%{name}/demo/*
%dir %{_datadir}/%{name}/examples
%{_datadir}/%{name}/examples/*
%dir %{_datadir}/%{name}/effects
%{_datadir}/%{name}/effects/*
%dir %{_datadir}/%{name}/ragamatic
%{_datadir}/%{name}/ragamatic/*

%changelog
* Mon Nov 16 2009 Toni Graffy <toni@links2linux.de> - 4.4.1-0.pm.1
- initial build 4.4.1
- spec based on fedora-ccrma spec
